#ifndef __IKD_TOOLS_LINKLINE_H__
#define __IKD_TOOLS_LINKLINE_H__


// NC
//
//  oN@\t̃CBn_ƏI_Ő\

#include "Float2.h"

namespace Tools {

	struct LinkLine {
		LinkLine() {}
		LinkLine( const Double2 &s, const Double2 &e ) : next_(), pre_(), group_( -1 ) {
			set( s, e );
		}
		void set( const Double2 &s, const Double2 &e ) {
			aabb.set( s.x, s.y, e.x, e.y, this );
			s_ = s;
			e_ = e;
		}

		// ̏I[ɂȂ
		bool tryLink( LinkLine *child, double percision, bool allowInverse ) {
			// endchildstartWȂ烊N
			if ( e_ == child->s_ ) {
				next_ = child;
				child->pre_ = this;
				return true;
			}
			if ( allowInverse == true ) {
				// endƑendWȂ瑊̓_̎n_/I_ւăN
				if ( e_ == child->e_ ) {
					auto tmp = child->s_;
					child->s_ = child->e_;
					child->e_ = tmp;
					next_ = child;
					child->pre_ = this;
					return true;
				}
			}
			return false;
		}

		// ʐH
		bool isSame( const LinkLine *other, bool allowInverse = true, bool ignoreSelf = true ) {
			if ( ignoreSelf == true && other == this )
				return false;
			if ( other->s_ == s_ && other->e_ == e_ ) {
				return true;
			}
			if ( allowInverse == true ) {
				if ( other->s_ == e_ && other->e_ == s_ ) {
					return true;
				}
			}
			return false;
		}

		Double2 s_, e_;
		LinkLine *next_;
		LinkLine *pre_;
		CellContainer< LinkLine* >::AABB aabb;
		int32_t group_;
	};
}
#endif
